addhook("startround", "nz_startRound")
addhook("endround", "nz_endRound") 

function nz_waveTimer()
	nz_waveTime = nz_waveTime - 1
end
--10
function nz_updateBots()
	local playerCount = 0
	local botCount = 0
	local botNeeded = 4
	for _, v in ipairs(player(0, "table")) do
		if player(v, "bot") == false then 
			playerCount = (playerCount + 1)
		else
			botCount = botCount + 1
		end
	end

	if playerCount == 2 then 
		botNeeded = botNeeded + 2
	end
	if playerCount == 3 then
		botNeeded = botNeeded + 3
	end
	if playerCount == 4 then
		botNeeded = botNeeded + 4
	end
	if playerCount == 5 then
		botNeeded = botNeeded + 5
	end
	if playerCount >= 6 then
		botNeeded = botNeeded + 6

	end

	-- add more bots if more bots is needed
	if (botCount < botNeeded) then
		repeat
			parse("bot_add_t")			
			botCount = botCount + 1
		until botCount == botNeeded
	-- remove bots if there is more bots than what is needed
	elseif (botCount > botNeeded) then
		for _, v in ipairs(player(0, "table")) do
			if (player(v, "bot") and botCount > botNeeded) then
				botCount = botCount - 1
				parse("kick "..v)
			end
		end
	end
end

function nz_nextWave()
	-- reset the wave timer
	nz_waveTime = 60
	-- increment the wave
	if nz_wave < 30 then
		nz_wave = nz_wave + 1
		else
			nz_wave = nz_wave
	end
	
	-- destroy all of the barbed wire on the map
	for _, v in ipairs(object(0, "table")) do
		if (object(v, "type") == 2) then
			parse("killobject "..v)
		end
	end

	-- Msg 1 --
	if nz_wave == 1 then
	msg("032032255The satellite images show that something")
	msg("032032255is moving towards you. Prepare!")
	end

	-- Msg 2 --

	if nz_wave == 2 then
	msg("032032255You can buy ammo from the walls.")
	msg("032032255Also, repair the wire by pressing E.")
	end

	-- door1 open --
	if nz_wave == 6 then
	parse("trigger d1")
	parse("trigger d2")
	parse("trigger z2")
	msg("032032255We hacked the first door!@C")
	end
	-- door 2 open --
	if nz_wave == 11 then
	parse("trigger d3")
	parse("trigger d4")
	parse("trigger z1")
	parse("trigger z2")
	parse("trigger z3")
	parse("bot_kill")
	msg("032032255Bad news, theres toxic gas spreading!")
	msg("032032255Go to the underground while we search")
	msg("032032255for alternate escape route.")
	botNeeded = botNeeded + 2
	end

	-- door 3 open --
	if nz_wave == 12 then
	parse("trigger c2")
	parse("trigger c1")
parse("trigger z3")
	parse("trigger z4")
	parse("trigger d5")
	parse ("trigger d6")
	parse("trigger toxic1")
	msg("032032255The gas is spreading! Dont go back!")
	end

	-- door 3 open --
	if nz_wave == 14 then
	parse("trigger z4")
	parse("trigger z5")
	parse("trigger d7")
	parse ("trigger d8")
	msg("032032255We got the third door!")
	end

	if nz_wave == 15 then
	parse("trigger c3")
	parse("trigger c2")
	parse("trigger z6")
	parse("trigger d9")
	parse ("trigger d10")
	parse("trigger toxic2")
	msg("032032255The toxic gas is spreading faster!")
	botNeeded = botNeeded + 2
	end
	if nz_wave == 16 then
	parse("trigger c4")
	parse("trigger c3")
	parse("trigger z7")
	parse("trigger d11")
	parse ("trigger d12")
	parse ("trigger toxic3")
	end
	if nz_wave == 17 then
	parse("trigger c5")
	parse("trigger c4")
	parse("trigger z6")
parse("trigger z5")
	parse ("trigger toxic4")
	end
	if nz_wave == 20 then
	parse("trigger c6")
	parse("trigger c5")
	parse("trigger z8")
	parse("trigger z7")
	parse("trigger d13")
	parse("trigger d14")
	parse("trigger toxic5")
	botNeeded = botNeeded + 2
	end
	if nz_wave == 22 then
	parse("trigger z9")
	parse("trigger toxic6")
	parse("trigger z8")
	parse("trigger d15")
	parse("trigger d16")
	parse("trigger c7")
	parse("trigger c6")
	end
	if nz_wave == 23 then
	parse("trigger toxic7")
	end
	if nz_wave == 26 then
	botNeeded = botNeeded + 2
		if math.random(1,2)==1 then
			parse("spawnitem 40 109 84")
			parse("spawnitem 40 110 84")
			else
				parse("spawnitem 45 109 84")
				parse("spawnitem 45 110 84")
		end
	end
	
	if nz_wave == 30 and nz_lastWave == false then
	parse("trigger freeammo")
	botNeeded = botNeeded + 10
	parse("trigger bosswall")
	end
	-- create new barbed wire on the map
	for x = 0, map("xsize") do
		for y = 0, map("ysize") do
			if (entity(x, y, "exists")) then
				if (entity(x, y, "trigger") == "barbedwire") then
						parse("mp_killbuildings 2")
						parse("spawnobject 2 "..x.." "..y.." 0 0 0 0")
				end
			end
		end
	end
	
	for _, v in ipairs(player(0, "table")) do
		-- put all of the dead players back into survivor
		if (not player(v, "bot")) then
			if (player(v, "team")) == 0 then
				parse("makect " ..v)
			end
		end
		
		-- kill all of the zombie expect for bosses
		if (player(v, "bot")) then
			if (nz_class[v] ~= "meth" and nz_class[v] ~= "darth valdamere" and nz_class[v] ~= "titan" and nz_class[v] ~= "dread" and nz_class[v] ~= "dc") then
				if nz_wave < 30 then
				parse("killplayer " ..v)
				end
			end
		end
	end
	
	-- update the zombie count
	nz_updateBots()
	
	-- display a message about the next wave
	if nz_wave < 30 then
		msg("032255032Prepare for wave "..nz_wave.."!@C")
	end
	if nz_lastWave == false and nz_wave == 30 then
			msg("032255032Prepare for the last wave!@C")	
	end
end

function nz_startRound(mode)
	-- reset the game data
	nz_wave = 0
	nz_spawnPoint = {}
	nz_openedDoor = {}
	nz_waveTime = 60
	
	-- reset the boss zombie data
	nz_meth = false
	nz_darthValdamere = false
	nz_lastWave = false
	nz_titan = false
	nz_dread = false
	nz_dc = false

	-- restart the map barbed wire and spawn point
	for x = 0, map("xsize") do
		for y = 0, map("ysize") do
			if (entity(x, y, "exists")) then
				-- look for new spawn point that only trigger when the corresponding door is opened
				if (entity(x, y, "name"):sub(1, #"spawn") == "spawn") then
					local newSpawn = true
					
					-- check if the spawn point name have already been checked
					for _, v in ipairs(nz_spawnPoint) do
						if (v == entity(x, y, "name")) then
							newSpawn = false
						end
					end
					
					-- disable the spawn point and add it to the spawn table
					if (newSpawn) then
						table.insert(nz_spawnPoint, entity(x, y, "name"))
					
						trigger(entity(x, y, "name"))
					end
				-- create barbed wires at entity with the trigger barbedwire
				elseif (entity(x, y, "trigger") == "barbedwire") then
					if nz_lastWave == false then
						parse("spawnobject 2 "..x.." "..y.." 0 0 0 0")
					end
				end
			end
		end
	end
	
	-- put all of the bots into the zombie team and all of the players into the survivor name and reset their money
	for _, v in ipairs(player(0, "table")) do
		-- put the bot into the zombie team
		if (player(v, "bot")) then
			parse("maket " ..v)
		-- put the player into the survivor team
		elseif (not player(v, "bot")) then
			if nz_wave < 30 then
				if (player(v, "team")) == 0 then
				parse("makect " ..v)
				end
			end
		end
		
		-- reset their money
		nz_money[v] = 0
	end
	
	-- initialize the first wave
	nz_nextWave()
	
	-- free the timer
	freetimer("nz_waveTimer")
	freetimer("nz_nextWave")

	timer(1000, "nz_waveTimer", "", 0)
	timer(60000, "nz_nextWave", "", 0)
end

function nz_endRound(mode)
	-- reset all of the player money (player spawn before the start round hook initialize)
	for _, v in ipairs(player(0, "table")) do
		nz_money[v] = 0
	end
end