-- Nazi Zombie
-- v1.0
-- Author: Bownok
parse("sv_map zm_ReseachSite")
-- initialize the mod

-- file directory
nz_MAIN = "sys/lua/"
nz_IMAGES = "sys/lua/"

-- initialize game data
nz_wave = 0
nz_waveTime = 60 -- round time is in seconds

nz_spawnPoint = {}
nz_openedDoor = {}
nz_itemPrice = {}

nz_meth = false
nz_dread = false
nz_titan = false
nz_dc = false

-- initialize players data
nz_tutorial = {}

-- zombie data
nz_class = {}
nz_maxHealth = {}
nz_health = {}
nz_speedMod = {}
nz_bounty = {}
nz_image = {}

-- survivor data
nz_money = {}
nz_doorName = {}
nz_doorPrice = {}
nz_itemSelection = {}

-- player position data
nz_lastX = {}
nz_lastY = {}
nz_lastTileX = {}
nz_lastTileY = {}

-- load settings
		parse("mp_wpndmg p228 175")
		parse("mp_wpndmg glock 180")
		parse("mp_wpndmg deagle 425") 
		parse("mp_wpndmg xm1014 105") 
		parse("mp_wpndmg m3 175") 
		parse("mp_wpndmg mp5 90") 
		parse("mp_wpndmg tmp 70") 
		parse("mp_wpndmg mac10 75") 
		parse("mp_wpndmg m249 95") 
		parse("mp_wpndmg laser 750") 
		parse("mp_wpndmg flamethrower 160") 
		parse("mp_wpndmg rpglauncher 2510") 
		parse("mp_wpndmg p90 85") 
		parse("mp_wpndmg elite 235") 
		parse("mp_wpndmg ump45 100") 
		parse("mp_wpndmg usp 170")
		parse('mp_building_health "Barbed wire" 1000')

-- load scripts
dofile(nz_MAIN.."game.lua")
dofile(nz_MAIN.."player.lua")

-- restart the round to initialize all data properly
parse("restart")